% Author: Rodrigo Carceroni
% Disclaimer: This code comes with no guarantee at all and its author
%   is not liable for any damage that its utilization may cause.
%khw21.0304%
function R = roll_pitch_yaw_mat2 (angs) % rotate x(rool) first, then y(pitch), then z*yaw)
%The yaw, pitch, and roll rotations can be used to place a 3D body in any orientation
% first roll (around(x), pitch (around y); final yaw (around z),see http://planning.cs.uiuc.edu/node102.html
% Return the 3x3 rotation matrix described by a set of Roll, Pitch and Yaw
% angles.

% cosA = cos (angs(3));
% sinA = sin (angs(3));
% cosB = cos (angs(2));
% sinB = sin (angs(2));
% cosC = cos (angs(1));
% sinC = sin (angs(1));
% 
% cosAsinB = cosA .* sinB;
% sinAsinB = sinA .* sinB;
% 
% R = [ cosA.*cosB  cosAsinB.*sinC-sinA.*cosC  cosAsinB.*cosC+sinA.*sinC ;
%       sinA.*cosB  sinAsinB.*sinC+cosA.*cosC  sinAsinB.*cosC-cosA.*sinC ;
%         -sinB            cosB.*sinC                 cosB.*cosC         ];
    
% % same as berlow
an_x=angs(1);
an_y=angs(2);
an_z=angs(3);
%below are Rcam
Rz=[cos(an_z)   -sin(an_z)   0
   sin(an_z)   cos(an_z)   0
    0           0           1];
Ry=[cos(an_y)   0           sin(an_y)
    0           1           0 
   -sin(an_y)    0           cos(an_y)];
Rx=[1           0           0
    0           cos(an_x)   -sin(an_x)
    0           sin(an_x)  cos(an_x)];
%R= Rz*Ry*Rx %rotate x first, then y, final z
R= Rz*Ry*Rx ;%rotate x first, then y, final z
% 
