function sfm1
%test pose estimation. Use number of pixesl for all measures 

%% generate data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear
pixel_per_meter=5*10^-6; %5um

f=4*10^-3/pixel_per_meter;%focal length =4mm

N=50; %N=num of features
randon_gen_tag=1;
if (randon_gen_tag==1)
 %X=(rand(3,N)*0.1+repmat(Z_center,1,N))/pixel_per_meter %repmat(Z_center,1,N),so two terms can add
X=rand(3,N)*0.05/pixel_per_meter;

 % X=repmat([X;1],1,N) % homogenous coord)
else
%     N=4
%     X=  [0.0000    0.0000    0.0000    0.0000
%         -0.1997   -0.1997   -0.1997   -0.1997
%         1.9900    1.9900    1.9900    1.9900]
       
end ;
    %motion of object [ang_x,ang_y,ang_z,T1,T2,T3], ang_z in radian,T in pixles
Z_center=1/pixel_per_meter; %[0 0 1]' %center of gravity of the object= 1 meter from the camera center
theta=([0 0 Z_center 10*pi/180 20*pi/180 30*pi/180]'); %make it radian

Z_init=2/pixel_per_meter;
theta_guessed=([0 0 Z_init  0*pi/180 5.5*pi/180 0*pi/180]'); %first guess


R=rpyMat([theta(4), theta(5),theta(6)]);
R_guessed=rpyMat([theta_guessed(4), theta_guessed(5),theta_guessed(6)]);

X_new=R*X+repmat(theta(1:3),1,N); %X_neww new position of the object

% %image is projected from X_new, ixy=[u,v]'=image point
% figure(1)
% clf
% hold on
% for j=1:N
%     ixy(2*(j-1)+1,1)=[f*X_new(1,j)/X_new(3,j)];
%     ixy(2*(j-1)+2,1)=[f*X_new(2,j)/X_new(3,j)];
%     plot(ixy(2*(j-1)+1,1), ixy(2*(j-1)+2,1),'ro');
% end

actual_image=[f*X_new(1,:)./X_new(3,:)
              f*X_new(2,:)./X_new(3,:)];
   
%plot images
figure(1)
clf
hold on
plot(actual_image(1,:),actual_image(2,:),'ro');
title('image features')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%function Soultion - ishii(Model, ActualImg, InitTr, fLen, numIter)
pose_Solution=ishii(X,actual_image, [R_guessed,[0 0 Z_init]'], f,30,actual_image);
pose_Solution


